package com.inca.npbusi.sacon.bms_sa_con;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.ParamCommand;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CHovBase;
import com.inca.np.gui.control.DBColumnDisplayInfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMasterModel;
import com.inca.np.util.SendHelper;
import com.inca.npbusi.datacheck.checkprice.Npbusicheckprice;
import com.inca.npbusi.sacon.bms_sa_con.weborder.Web_sa_con_mde;
import com.inca.npbusi.sacon.bms_sa_con.weborder.Weborder_sa_con_hov;
import com.inca.npx.mde.CMdeModelAp;
import com.inca.npx.ste.Apinfo;
import com.inca.pubsrv.ApproveDialog;
import com.inca.pubsrv.Entrychose;
import com.inca.pubsrv.NpbusiDBHelper;
import com.inca.pubsrv.NptrDBHelper;
import com.inca.pubsrv.mpcsprodHelper;
import com.inca.pubsrv.bms_wf_instance_qry.Bms_wf_instance_qry_hov;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Vector;
import javax.swing.JOptionPane;

public class Bms_sa_con_mde extends CMdeModelAp {
   private ApproveDialog a;
   private String b = "";
   private String c = "";
   protected String nosapriceinfo = "";
   private CHovBase d = null;

   public String getEntryid() {
      return this.b;
   }

   public void setEntryid(String var1) {
      this.b = var1;
   }

   public String getEntryname() {
      return this.c;
   }

   public void setEntryname(String var1) {
      this.c = var1;
   }

   public Bms_sa_con_mde(CFrame var1, String var2) {
      super(var1, var2);
      this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
      this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
   }

   protected CMasterModel createMastermodel() {
      return new Bms_sa_con_master(this.frame, this);
   }

   protected CDetailModel createDetailmodel() {
      return new Bms_sa_con_detail(this.frame, this);
   }

   public String getMasterRelatecolname() {
      return "conid";
   }

   public String getDetailRelatecolname() {
      return "conid";
   }

   public String getSaveCommandString() {
      return "Bms_sa_con_mde.保存销售订单";
   }

   protected int on_beforemodifymaster(int var1) {
      return 0;
   }

   public Vector<Apinfo> getParamapinfos() {
      Vector var1;
      (var1 = new Vector()).add(new Apinfo("销售模式", ""));
      var1.add(new Apinfo("结算方式", ""));
      var1.add(new Apinfo("配货模式", ""));
      var1.add(new Apinfo("审批权限", ""));
      var1.add(new Apinfo("禁止确定", "1"));
      var1.add(new Apinfo("禁止回退确定", "1"));
      var1.add(new Apinfo("禁止作废", "1"));
      var1.add(new Apinfo("是否业务员开票", ""));
      var1.add(new Apinfo("大库保管账", ""));
      var1.add(new Apinfo("勾兑网上订单", ""));
      if (mpcsprodHelper.getSysProdConfig(ClientUserManager.getCurrentUser().getEntryid(), "prod202004").equals("1")) {
         var1.add(new Apinfo("回执确认", ""));
         var1.add(new Apinfo("取消回执", ""));
      }

      return var1;
   }

   protected int on_actionPerformed(String var1) {
      if (!var1.equals("提交订单")) {
         String var18;
         if (var1.equals("审批")) {
            var18 = this.getApvalue("审批权限");
            if ("1".equals(var18)) {
               this.a();
            } else {
               this.infoMessage("提示", "没有审批权限不能审批！");
            }

            return 0;
         } else if (var1.equals("确定")) {
            var18 = this.getApvalue("禁止确定");
            if ("1".equals(var18)) {
               this.infoMessage("提示", "对不起，您没有执行此操作的权限！");
               return -1;
            } else {
               this.b();
               return 0;
            }
         } else if (var1.equals("回退确定")) {
            var18 = this.getApvalue("禁止回退确定");
            if ("1".equals(var18)) {
               this.infoMessage("提示", "对不起，您没有执行此操作的权限！");
               return -1;
            } else {
               this.c();
               return 0;
            }
         } else if (var1.equals("作废")) {
            var18 = this.getApvalue("禁止作废");
            if ("1".equals(var18)) {
               this.infoMessage("提示", "对不起，您没有执行此操作的权限！");
               return -1;
            } else {
               this.d();
               return 0;
            }
         } else if (var1.equals("切换独立单元")) {
            if (this.mastermodel.getModifiedDbmodel().getRowCount() > 0) {
               this.infoMessage("提示", "有尚未保存的数据，请先作保存！");
               return -1;
            } else {
               if (Entrychose.setUserEntryInfo(this.frame)) {
                  this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
                  this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
                  this.getMasterModel().doRetrieve("1=2");
               }

               return 0;
            }
         } else {
            if (var1.equals("送审")) {
               var18 = "";

               try {
                  var18 = NpbusiDBHelper.getSysParaConfig(this.getEntryid(), "wf1067");
               } catch (Exception var16) {
                  var16.printStackTrace();
               }

               if (!var18.equals("1")) {
                  this.infoMessage("提示！", "请启动审批流再送审！");
                  return 0;
               }

               this.f();
            }

            int var21;
            if (var1.equals("查看审批流")) {
               if (this.getMasterModel().getRowCount() <= 0) {
                  this.infoMessage("提示", "请选中数据行！");
               } else {
                  var21 = this.getMasterModel().getRow();
                  Bms_wf_instance_qry_hov var20 = new Bms_wf_instance_qry_hov();
                  String var23 = this.getMasterModel().getItemValue(var21, "conid");
                  String var26 = " TABLENAME LIKE 'BMS_SA_CON_DOC'   AND PKCOLNAME LIKE 'CONID' and PKVALUE =" + var23;
                  var20.showDialog(this.frame, "查看审批流", "TABLENAME", "%", var26);
               }
            }

            if (var1.equals("回执确认")) {
               if (!"1".equals(this.getApvalue("回执确认"))) {
                  this.infoMessage("提示", "对不起，您没有执行此操作的权限！");
                  return -1;
               }

               this.receiptCon();
            }

            if (var1.equals("取消回执")) {
               if (!"1".equals(this.getApvalue("取消回执"))) {
                  this.infoMessage("提示", "对不起，您没有执行此操作的权限！");
                  return -1;
               }

               var21 = this.getMasterModel().getRow();
               if (this.getMasterModel().getItemValue(var21, "receiptstatus").equals("1")) {
                  this.getMasterModel().setItemValue(var21, "receiptstatus", "0");
                  this.getMasterModel().setItemValue(var21, "receiptmanid", "");
                  this.getMasterModel().setItemValue(var21, "receiptdate", "");
               }

               this.doSaveSlient();
            }

            var1.equals("多选有库存货品");
            if (var1.equals("勾兑网上订单")) {
               var18 = this.getApvalue("勾兑网上订单");
               if (!"1".equals(var18)) {
                  this.infoMessage("提示", "对不起，您没有执行此操作的权限！");
                  return -1;
               }

               this.d = new Weborder_sa_con_hov();
               Weborder_sa_con_hov var25 = (Weborder_sa_con_hov)this.d;
               String var22 = " ddtype in(1,2) and usestatus in(4,7,12,13) and dtlcount>0 and  exists (select 1 from web_sa_con_dtl m where m.websacondocid=websacondocid and m.usestatus is null ) and entryid=" + ClientUserManager.getCurrentUser().getEntryid();
               var25.setDetailOtherWhere(" nvl(fhgoodsqty,0)<>nvl(goodsqty,0) and nvl(creflag,0) <>1 and nvl(usestatus,-1)=-1");
               if (this.d.showDialog(this.frame, "由网购订单生成", "zdid", "", var22) != null) {
                  Map var30;
                  if ((var30 = a(((Web_sa_con_mde)((Weborder_sa_con_hov)this.d).getMdemodel()).echoRecord())).size() == 0) {
                     this.infoMessage("提示", "没有选中的行或总单不存在保管帐信息或细单没有指定货品明细,\n不需要生成“销售订单数据”");
                  } else {
                     this.a(var30);
                     this.getDetailModel().tableChanged();
                     this.getMasterModel().tableChanged();
                  }
               }
            }

            return super.on_actionPerformed(var1);
         }
      } else {
         Bms_sa_con_mde var2 = this;
         int[] var4;
         if ((var4 = this.getMasterModel().getTable().getSelectedRows()).length <= 0) {
            this.warnMessage("提示", "请多选销售订单进行提交！");
         } else if (this.getDetailModel().getDBtableModel().getRowCount() <= 0) {
            this.warnMessage("提示", "无细单，不能提交！");
         } else {
            Vector var17 = new Vector();
            DBColumnDisplayInfo var3 = new DBColumnDisplayInfo("conid", "number");
            var17.add(var3);
            var3 = new DBColumnDisplayInfo("message", "varchar");
            var17.add(var3);
            var3 = new DBColumnDisplayInfo("approveflag", "number");
            var17.add(var3);
            var3 = new DBColumnDisplayInfo("isCommit", "varchar");
            var17.add(var3);
            DBTableModel var19 = new DBTableModel(var17);
            int var5 = 0;

            while(true) {
               if (var5 >= var4.length) {
                  ClientRequest var24 = new ClientRequest("Bms_sa_con_mde.销售订单提交");
                  DataCommand var27;
                  (var27 = new DataCommand()).setDbmodel(var19);
                  var24.addCommand(var27);
                  var2.setWaitCursor();

                  try {
                     try {
                        ServerResponse var28 = SendHelper.sendRequest(var24);
                        var2.a(var28, "提交", 2, 2, 1);
                     } catch (Exception var14) {
                        var2.errorMessage("错误", var14.getMessage());
                     }
                     break;
                  } finally {
                     var2.setDefaultCursor();
                  }
               }

               int var6 = var4[var5];
               String var7 = var2.getMasterModel().getItemValue(var6, "conid");
               if (var2.getMasterModel().getdbStatus(var6) != 0) {
                  var2.warnMessage("提示", "第" + (var6 + 1) + "行销售订单没有保存，不能提交！");
                  break;
               }

               if (!var2.getMasterModel().getItemValue(var6, "usestatus").equals("1")) {
                  var2.warnMessage("提示", "第" + (var6 + 1) + "行销售订单不是临时状态，不能提交！");
                  break;
               }

               if (!var2.getMasterModel().getItemValue(var6, "approveflag").equals("0")) {
                  var2.warnMessage("提示", "第" + (var6 + 1) + "行销售订单审批状态不是初始状态，不能提交！");
                  break;
               }

               var1 = var2.getMasterModel().getItemValue(var6, "entryid");
               String var8 = var2.getMasterModel().getItemValue(var6, "storageid");
               String var9 = var2.getMasterModel().getItemValue(var6, "targetposid");
               if (var8 != null && var8.trim().length() > 0 && NptrDBHelper.checkWmsflag(var8, var1) && (var9 == null || var9.trim().length() <= 0)) {
                  var2.infoMessage("提示", "第" + (var6 + 1) + "销售订单的保管帐为物流保管帐，需要维护送货地点");
                  break;
               }

               DBTableModel var29;
               if ((var29 = var2.getDetaildbmodel(var6)) != null) {
                  for(var6 = 0; var6 < var29.getRowCount(); ++var6) {
                     var9 = var29.getItemValue(var6, "goodsid");
                     String var10 = var29.getItemValue(var6, "unitprice");
                     if (!Npbusicheckprice.fitPrice(var9, var10, 2, var1)) {
                        int var31 = JOptionPane.showConfirmDialog(var2.frame, "销售价格必须高于批发最低限价，低于国家零售价\n是否继续？");
                        var29.getRecordThunk(var5).setSaveresult(-1, "价格必须高于批发最低限价，低于国家零售价");
                        var2.detailmodel.tableChanged();
                        if (var31 != 0) {
                           return 0;
                        }
                     }

                     var29.getRecordThunk(var5).setSaveresult(0, "");
                  }
               }

               var6 = var19.getRowCount();
               var19.appendRow();
               var19.setItemValue(var6, "conid", var7);
               var19.setItemValue(var6, "isCommit", "1");
               ++var5;
            }
         }

         return 0;
      }
   }

   private static Map<String, List<String>> a(DBTableModel var0) {
      new ArrayList();
      String var1 = null;
      HashMap var2 = new HashMap();

      for(int var3 = 0; var3 < var0.getRowCount(); ++var3) {
         var1 = var0.getItemValue(var3, "storageid");
         String var4 = var0.getItemValue(var3, "goodsdtlid");
         if (var1 == null || var1.trim().length() == 0) {
            return new HashMap();
         }

         if (var4 != null && var4.trim().length() > 0) {
            String var5 = var0.getItemValue(var3, "customerid");
            String var6 = var0.getItemValue(var3, "entryid");
            String var7 = var0.getItemValue(var3, "ddtype");
            String var8 = var0.getItemValue(var3, "tranposid");
            var5 = var5 + "_" + var1 + "_" + var6 + "_" + var8 + "_" + var7;
            Object var9;
            if (var2.containsKey(var5)) {
               var9 = (List)var2.get(var5);
            } else {
               var9 = new ArrayList();
               var2.put(var5, var9);
            }

            var6 = var0.getItemValue(var3, "websacondtlid");
            ((List)var9).add(var6 + "@" + var4);
            if (((List)var9).size() == 0) {
               var2.remove(var5);
            }
         }
      }

      return var2;
   }

   private void a(Map<String, List<String>> var1) {
      StringBuffer var2 = new StringBuffer();
      String var3 = ",";
      String var4 = "__";
      String var5 = ";";
      Iterator var6 = var1.keySet().iterator();

      String var7;
      List var8;
      while(var6.hasNext()) {
         var7 = (String)var6.next();
         var2.append(var7);
         var2.append(var4);
         var8 = (List)var1.get(var7);

         for(int var11 = 0; var11 < var8.size(); ++var11) {
            var2.append((String)var8.get(var11));
            var2.append(var3);
         }

         var2.append(var5);
      }

      ClientRequest var12;
      (var12 = new ClientRequest()).addCommand(new StringCommand("Web_sa_con.创建销售订单"));
      var12.addCommand(new StringCommand(var2.toString()));
      var8 = null;

      try {
         ServerResponse var13;
         var7 = ((StringCommand)(var13 = SendHelper.sendRequest(var12)).commandAt(0)).getString();
         String var10 = ((StringCommand)var13.commandAt(1)).getString();
         if (var7.trim().startsWith("+OK")) {
            this.infoMessage("提示", String.format("创建%s条销售订单单据", var1.size()) + "；单据ID：" + var10 + "。");
            this.mastermodel.doQuery("conid in (" + var10 + ")");
         } else {
            this.errorMessage("错误", var7);
         }
      } catch (Exception var9) {
         var9.printStackTrace();
         this.errorMessage("错误", var9.getMessage());
      }
   }

   public void receiptCon() {
      int var1 = this.getMasterModel().getRow();
      String var2 = this.getMasterModel().getItemValue(var1, "receiptstatus");
      String var3 = ClientUserManager.getCurrentUser().getUserid();
      Date var4 = new Date();
      String var6 = (new SimpleDateFormat("yyyy-MM-dd")).format(var4);
      if (!var2.equals("1")) {
         this.getMasterModel().setItemValue(var1, "receiptstatus", "1");
         this.getMasterModel().setItemValue(var1, "receiptmanid", var3);
         this.getMasterModel().setItemValue(var1, "receiptdate", var6);
      }

      this.doSaveSlient();
   }

   private void a() {
      if (this.getMasterModel().getRow() < 0) {
         this.warnMessage("警告", "请选择正确的单据进行审批!");
      } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请选择正确的单据进行审批!");
      } else {
         for(int var1 = 0; var1 < this.getMasterModel().getRowCount(); ++var1) {
            if (this.getMasterModel().getdbStatus(var1) != 0) {
               this.warnMessage("警告", "没有保存不能审批,请先保存!");
               return;
            }
         }

         String var9 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "approveflag");
         if ("0".equals(var9)) {
            this.warnMessage("警告", "请先提交订单，再进行审批！");
         } else if (!"1".equals(var9) && !"3".equals(var9)) {
            var9 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "usestatus");
            if (!"1".equals(var9)) {
               this.warnMessage("警告", "选中行虽然是待审批状态，但是使用状态不是临时，因此不能审批！");
            } else {
               var9 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "conid");
               String var2 = "";
               DBTableModel var3 = null;
               String var4 = " select savememo from bms_sa_approve_memo where sourceid= " + var9 + " and comefrom = 1";
               RemotesqlHelper var5 = new RemotesqlHelper();

               try {
                  var3 = var5.doSelect(var4, 0, 1);
               } catch (Exception var7) {
                  var7.printStackTrace();
               }

               if (var3 != null && var3.getRowCount() > 0) {
                  var2 = var3.getItemValue(0, "savememo");
               }

               ClientRequest var13 = new ClientRequest();
               StringCommand var12 = new StringCommand("Bms_sa_con_mde.销售订单提交");
               Vector var14 = new Vector();
               DBColumnDisplayInfo var6 = new DBColumnDisplayInfo("conid", "number");
               var14.add(var6);
               var6 = new DBColumnDisplayInfo("message", "varchar");
               var14.add(var6);
               var6 = new DBColumnDisplayInfo("approvememo", "varchar");
               var14.add(var6);
               var6 = new DBColumnDisplayInfo("isCommit", "varchar");
               var14.add(var6);
               DBTableModel var15;
               (var15 = new DBTableModel(var14)).appendRow();
               var15.setItemValue(0, "conid", var9);
               var15.setItemValue(0, "isCommit", "0");
               DataCommand var10;
               (var10 = new DataCommand()).setDbmodel(var15);
               var13.addCommand(var12);
               var13.addCommand(var10);
               var9 = null;

               try {
                  ServerResponse var11;
                  if (!(var12 = (StringCommand)(var11 = SendHelper.sendRequest(var13)).commandAt(0)).getString().startsWith("+OK")) {
                     this.errorMessage("错误", "审批不成功原因:" + var12.getString());
                     return;
                  }

                  var9 = ((DataCommand)var11.commandAt(1)).getDbmodel().getItemValue(0, "approvememo");
                  if (this.a == null || !this.a.isVisible()) {
                     this.a = new ApproveDialog(this.frame, "销售发货单审批", this);
                     this.a.pack();
                     this.a.setLocation((int)((Toolkit.getDefaultToolkit().getScreenSize().getWidth() - (double)this.a.getWidth()) / 2.0), (int)((Toolkit.getDefaultToolkit().getScreenSize().getHeight() - (double)this.a.getHeight()) / 2.0));
                     this.a.setVisible(true);
                     this.a.setAlwaysOnTop(true);
                     this.a.getappcheckarea().setText(var9);
                     this.a.getcommitcheckarea().setText(var2);
                     return;
                  }
               } catch (Exception var8) {
                  this.errorMessage("错误", "审批不成功原因:" + var8.getMessage());
                  var8.printStackTrace();
               }

            }
         } else {
            this.warnMessage("警告", "选中行不是待审批状态，不需审批！");
         }
      }
   }

   private void b() {
      if (this.getMasterModel().getRow() < 0) {
         this.warnMessage("警告", "请选择正确的单据进行确定!");
      } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请选择正确的单据进行确定!");
      } else {
         for(int var1 = 0; var1 < this.getMasterModel().getRowCount(); ++var1) {
            if (this.getMasterModel().getdbStatus(var1) != 0) {
               this.warnMessage("警告", "没有保存不能确定,请先保存!");
               return;
            }
         }

         String var12 = "";

         try {
            var12 = NpbusiDBHelper.getSysParaConfig(this.getEntryid(), "wf1067");
         } catch (Exception var9) {
            var9.printStackTrace();
         }

         String var2;
         if (var12.equals("1")) {
            if ((var2 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "wfusestatus")) == null) {
               var2 = "";
            }

            if (!"2".equals(var2)) {
               this.warnMessage("警告", "已启动审批流，没有审批完成，不能确定！");
               return;
            }
         }

         var2 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "approveflag");
         var12 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "usestatus");
         if (!"1".equals(var12)) {
            this.warnMessage("警告", "不是临时状态，不能确定！");
         } else if ("0".equals(var2)) {
            this.warnMessage("警告", "请先提交订单，再进行确定操作！");
         } else if ("2".equals(var2)) {
            this.warnMessage("警告", "没有审批，不能确定！");
         } else {
            var12 = this.mastermodel.getItemValue(this.mastermodel.getRow(), "entryid");

            for(int var13 = 0; var13 < this.detailmodel.getRowCount(); ++var13) {
               String var3 = this.detailmodel.getItemValue(var13, "goodsid");
               String var4 = this.detailmodel.getItemValue(var13, "unitprice");
               if (!Npbusicheckprice.fitPrice(var3, var4, 2, var12)) {
                  int var5 = JOptionPane.showConfirmDialog(this.frame, "销售价格必须高于批发最低限价，低于国家零售价\n是否继续？");
                  this.detailmodel.getDBtableModel().getRecordThunk(var13).setSaveresult(-1, "价格必须高于批发最低限价，低于国家零售价");
                  this.detailmodel.tableChanged();
                  if (var5 != 0) {
                     return;
                  }
               }

               this.detailmodel.getDBtableModel().getRecordThunk(var13).setSaveresult(0, "");
            }

            ClientRequest var17 = new ClientRequest();
            StringCommand var14 = new StringCommand("Bms_sa_con_mde.销售订单确定");
            DBTableModel var18;
            (var18 = e()).appendRow();
            String var20 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "conid");
            var18.setItemValue(0, "conid", var20);
            DataCommand var15;
            (var15 = new DataCommand()).setDbmodel(var18);
            var17.addCommand(var14);
            var17.addCommand(var15);
            ParamCommand var16 = new ParamCommand();
            this.a(var17, var16);
            this.setWaitCursor();
            var12 = null;

            try {
               ServerResponse var19 = SendHelper.sendRequest(var17);
               this.a(var19, "确定", 2, 5, 1);
               return;
            } catch (Exception var10) {
               this.errorMessage("错误", "确定不成功原因:" + var10.getMessage());
               var10.printStackTrace();
            } finally {
               this.setDefaultCursor();
            }

         }
      }
   }

   private void a(ClientRequest var1, ParamCommand var2) {
      int var3;
      if ((var3 = this.getDetailModel().getRowCount()) > 0) {
         int var4 = 0;

         for(int var5 = 0; var5 < var3; ++var5) {
            String var6 = this.getDetailModel().getItemValue(var5, "agrcondtlid");
            String var7 = this.getDetailModel().getItemValue(var5, "goodsqty");
            if (var6 != null && !"".equals(var6)) {
               if (var7 == null || "".equals(var7)) {
                  var7 = "0";
               }

               ++var4;
               var2.addParam("agrcondtlid@" + Integer.toString(var4 - 1), var6);
               var2.addParam("goodsqty@" + Integer.toString(var4 - 1), var7);
            }
         }

         var2.addParam("dtlcount", Integer.toString(var4));
         var1.addCommand(var2);
      }

   }

   private void c() {
      if (this.getMasterModel().getRow() < 0) {
         this.warnMessage("警告", "请选择正确的单据进行回退确定!");
      } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请选择正确的单据进行回退确定!");
      } else {
         for(int var1 = 0; var1 < this.getMasterModel().getRowCount(); ++var1) {
            if (this.getMasterModel().getdbStatus(var1) != 0) {
               this.warnMessage("警告", "没有保存不能回退确定,请先保存!");
               return;
            }
         }

         String var9 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "usestatus");
         if (!"2".equals(var9)) {
            this.warnMessage("警告", "不是正式状态，不能回退确定！");
         } else {
            ClientRequest var10 = new ClientRequest();
            StringCommand var2 = new StringCommand("Bms_sa_con_mde.销售订单回退确定");
            DBTableModel var3;
            (var3 = e()).appendRow();
            String var4 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "conid");
            var3.setItemValue(0, "conid", var4);
            DataCommand var13;
            (var13 = new DataCommand()).setDbmodel(var3);
            var10.addCommand(var2);
            var10.addCommand(var13);
            ParamCommand var11 = new ParamCommand();
            this.a(var10, var11);
            var2 = null;

            try {
               ServerResponse var12 = SendHelper.sendRequest(var10);
               this.a(var12, "回退确定", 2, 6, 1);
               return;
            } catch (Exception var7) {
               this.errorMessage("错误", "回退确定不成功原因:" + var7.getMessage());
               var7.printStackTrace();
            } finally {
               this.setDefaultCursor();
            }

         }
      }
   }

   private void d() {
      int var1;
      if ((var1 = this.getMasterModel().getRow()) >= 0 && var1 != this.getMasterModel().getDBtableModel().getRowCount()) {
         int var2;
         for(var2 = 0; var2 < this.getMasterModel().getRowCount(); ++var2) {
            if (this.getMasterModel().getdbStatus(var2) != 0) {
               this.warnMessage("警告", "没有保存不能作废,请先保存!");
               return;
            }
         }

         String var13;
         if ((var13 = this.getMasterModel().getItemValue(var1, "wfusestatus")) == null) {
            var13 = "";
         }

         if ("1".equals(var13)) {
            this.warnMessage("警告", "已送审，不能进行此操作！");
         } else if (this.getDetailModel().getRow() < 0) {
            this.warnMessage("警告", "请选择正确的单据进行作废!");
         } else if (this.getDetailModel().getRow() == this.getDetailModel().getDBtableModel().getRowCount()) {
            this.warnMessage("警告", "请选择正确的单据进行作废!");
         } else {
            var13 = this.getMasterModel().getItemValue(var1, "usestatus");
            if (!"2".equals(var13)) {
               this.warnMessage("警告", "只有正式状态可以作废！");
            } else {
               int[] var14;
               int var3 = (var14 = this.getDetailModel().getTable().getSelectedRows()).length;
               if (this.getDetailModel().getTable().getSelectedRow() == this.getDetailModel().getTable().getRowCount() - 1) {
                  this.warnMessage("警告", "选中行错误,请重新选择!!!");
               } else {
                  if (var14[var14.length - 1] == this.getDetailModel().getRowCount()) {
                     --var3;
                  }

                  String var12 = this.getMasterModel().getItemValue(var1, "conid");
                  Vector var4 = new Vector();
                  DBColumnDisplayInfo var6 = new DBColumnDisplayInfo("condtlid", "number");
                  var4.add(var6);
                  var6 = new DBColumnDisplayInfo("message", "varchar");
                  var4.add(var6);
                  var6 = new DBColumnDisplayInfo("conid", "number");
                  var4.add(var6);
                  var6 = new DBColumnDisplayInfo("usestatus", "number");
                  var4.add(var6);
                  var6 = new DBColumnDisplayInfo("invalidflag", "number");
                  var4.add(var6);
                  var6 = new DBColumnDisplayInfo("invalidmanid", "number");
                  var4.add(var6);
                  var6 = new DBColumnDisplayInfo("invalidmanname", "varchar");
                  var4.add(var6);
                  var6 = new DBColumnDisplayInfo("invalidtime", "date");
                  var4.add(var6);
                  var6 = new DBColumnDisplayInfo("dtl_lines", "number");
                  var4.add(var6);
                  var6 = new DBColumnDisplayInfo("total", "number");
                  var4.add(var6);
                  DBTableModel var15 = new DBTableModel(var4);

                  for(int var5 = 0; var5 < var3; ++var5) {
                     String var20 = this.getDetailModel().getItemValue(var14[var5], "invalidflag");
                     if (!"1".equals(var20)) {
                        if (this.getDetailModel().getdbStatus(var14[var5]) != 0) {
                           this.warnMessage("警告", "第" + (var14[var5] + 1) + "行细单没有保存不能作废,请先保存!");
                           return;
                        }

                        var20 = this.getDetailModel().getItemValue(var14[var5], "condtlid");
                        int var7 = var15.getRowCount();
                        var15.appendRow();
                        var15.setItemValue(var7, "conid", var12);
                        var15.setItemValue(var7, "condtlid", var20);
                     }
                  }

                  if (var15.getRowCount() > 0) {
                     ClientRequest var17 = new ClientRequest();
                     DataCommand var21;
                     (var21 = new DataCommand()).setDbmodel(var15);
                     var17.addCommand(new StringCommand("Bms_sa_con_mde.销售订单作废"));
                     var17.addCommand(var21);
                     ParamCommand var22 = new ParamCommand();
                     var2 = this.getDetailModel().getRow();
                     var3 = this.getMasterModel().getRow();
                     String var16;
                     String var18;
                     if ((var16 = this.getMasterModel().getItemValue(var3, "usestatus")).equals("1")) {
                        var22.addParam("usestatus", "1");
                        var17.addCommand(var22);
                     } else {
                        var18 = this.getDetailModel().getItemValue(var2, "agrcondtlid");
                        var13 = this.getDetailModel().getItemValue(var2, "goodsqty");
                        if (var18 != null && !"".equals(var18)) {
                           if (var13 == null || "".equals(var13)) {
                              var13 = "0";
                           }

                           var22.addParam("agrcondtlid", var18);
                           var22.addParam("goodsqty", var13);
                           var17.addCommand(var22);
                        } else {
                           var22.addParam("usestatus", var16);
                           var17.addCommand(var22);
                        }
                     }

                     this.setWaitCursor();
                     var18 = null;

                     try {
                        ServerResponse var19 = SendHelper.sendRequest(var17);
                        this.a(var19, "作废");
                        return;
                     } catch (Exception var10) {
                        var10.printStackTrace();
                        this.errorMessage("错误", "作废不成功,原因:" + var10.getMessage());
                     } finally {
                        this.setDefaultCursor();
                     }

                  }
               }
            }
         }
      } else {
         this.warnMessage("警告", "请选择正确的单据进行作废!");
      }
   }

   public void actionPerformed(ActionEvent var1) {
      if (var1.getActionCommand().equals("diglog-ok")) {
         if (this.a.getappacross().isSelected()) {
            this.a(true);
         }

         if (this.a.getbackcommit().isSelected()) {
            this.a(false);
         }

         this.a.getnoapp().isSelected();
      }

      super.actionPerformed(var1);
   }

   private void a(boolean var1) {
      String var2 = this.a.getappmemoarea().getText();
      String var3 = this.a.getappcheckarea().getText();
      String var4 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "conid");
      String var5 = "0";
      if (var1) {
         var5 = "1";
      }

      StringCommand var13 = new StringCommand("Bms_sa_con_mde.销售订单审批");
      ClientRequest var6 = new ClientRequest();
      Vector var7 = new Vector();
      DBColumnDisplayInfo var8 = new DBColumnDisplayInfo("conid", "number");
      var7.add(var8);
      var8 = new DBColumnDisplayInfo("message", "varchar");
      var7.add(var8);
      var8 = new DBColumnDisplayInfo("approve", "number");
      var7.add(var8);
      var8 = new DBColumnDisplayInfo("appcheckinfo", "number");
      var7.add(var8);
      var8 = new DBColumnDisplayInfo("approveflag", "number");
      var7.add(var8);
      var8 = new DBColumnDisplayInfo("approvemanname", "varchar");
      var7.add(var8);
      var8 = new DBColumnDisplayInfo("approvemanid", "number");
      var7.add(var8);
      var8 = new DBColumnDisplayInfo("approvedate", "date");
      var7.add(var8);
      var8 = new DBColumnDisplayInfo("approvememo", "varchar");
      var7.add(var8);
      DBTableModel var16;
      (var16 = new DBTableModel(var7)).appendRow();
      var16.setItemValue(0, "conid", var4);
      var16.setItemValue(0, "approve", var5);
      var16.setItemValue(0, "approvememo", var2);
      var16.setItemValue(0, "appcheckinfo", var3);
      DataCommand var15;
      (var15 = new DataCommand()).setDbmodel(var16);
      var6.addCommand(var13);
      var6.addCommand(var15);
      this.setWaitCursor();
      var13 = null;

      try {
         ServerResponse var14 = SendHelper.sendRequest(var6);
         this.a(var14, "审批", 4, 8, 1);
         return;
      } catch (Exception var11) {
         this.errorMessage("错误", "审批不成功原因:" + var11.getMessage());
         var11.printStackTrace();
      } finally {
         this.setDefaultCursor();
      }

   }

   private static DBTableModel e() {
      Vector var0 = new Vector();
      DBColumnDisplayInfo var1 = new DBColumnDisplayInfo("conid", "number");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("message", "varchar");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("usestatus", "number");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("confirmanid", "number");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("confirmanname", "varchar");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("confirmdate", "date");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("approveflag", "number");
      var0.add(var1);
      return new DBTableModel(var0);
   }

   private void a(ServerResponse var1, String var2, int var3, int var4, int var5) {
      String var6;
      if ((var6 = var1.getCommand()).startsWith("+OK")) {
         DBTableModel var14 = this.getMasterModel().getDBtableModel();
         String var7 = "conid";
         if (var5 == 0) {
            var14 = this.getDetailModel().getDBtableModel();
            var7 = "condtlid";
         }

         DBTableModel var13 = ((DataCommand)var1.commandAt(1)).getDbmodel();

         for(int var8 = 0; var8 < var13.getRowCount(); ++var8) {
            String var9 = var13.getItemValue(var8, var7);
            String var10 = var13.getItemValue(var8, "message");

            for(int var11 = 0; var11 < var14.getRowCount(); ++var11) {
               if (var14.getItemValue(var11, var7).equals(var9)) {
                  if (!var10.startsWith("+OK")) {
                     var14.getRecordThunk(var11).setSaveresult(1, var10);
                     break;
                  }

                  for(int var15 = var3; var15 <= var4; ++var15) {
                     var10 = var13.getColumnDBName(var15);
                     var14.setItemValue(var11, var10, var13.getItemValue(var8, var10));
                  }

                  var14.setdbStatus(var11, 0);
                  if (var2.equals("提交")) {
                     if (var14.getItemValue(var11, "approveflag").equals("2")) {
                        var14.getRecordThunk(var11).setSaveresult(0, var2 + "成功且需要审批!");
                     } else {
                        var14.getRecordThunk(var11).setSaveresult(0, var2 + "成功且不需审批!");
                     }
                  } else {
                     var14.getRecordThunk(var11).setSaveresult(0, var2 + "成功!");
                  }
                  break;
               }
            }
         }

         if (var5 == 1) {
            this.getMasterModel().tableChanged();
            this.getDetailModel().tableChanged();
            return;
         }

         if (var5 == 0) {
            this.getMasterModel().tableChanged();
            this.getDetailModel().tableChanged();
            return;
         }
      } else {
         this.errorMessage("错误", var6);
      }

   }

   private void a(ServerResponse var1, String var2) {
      String var3;
      if (!(var3 = var1.getCommand()).startsWith("+OK")) {
         this.errorMessage("错误", var3);
      } else {
         this.a(var1, var2, 4, 7, 0);
         DBTableModel var7;
         int var8 = (var7 = ((DataCommand)var1.commandAt(1)).getDbmodel()).getRowCount() - 1;
         var3 = var7.getItemValue(var8, "conid");
         DBTableModel var4 = this.getMasterModel().getDBtableModel();

         for(int var5 = 0; var5 < var4.getRowCount(); ++var5) {
            if (var4.getItemValue(var5, "conid").equals(var3)) {
               var4.setItemValue(var5, "usestatus", var7.getItemValue(var8, "usestatus"));
               var4.setItemValue(var5, "dtl_lines", var7.getItemValue(var8, "dtl_lines"));
               var4.setItemValue(var5, "total", var7.getItemValue(var8, "total"));
               var4.setdbStatus(var5, 0);
               this.getMasterModel().tableChanged();
               return;
            }
         }

      }
   }

   private void f() {
      if (this.getMasterModel().getRow() < 0) {
         this.warnMessage("警告", "请选择正确的单据!");
      } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请选择正确的单据!");
      } else {
         for(int var1 = 0; var1 < this.getMasterModel().getRowCount(); ++var1) {
            if (this.getMasterModel().getdbStatus(var1) != 0) {
               this.warnMessage("警告", "没有保存,请先保存!");
               return;
            }
         }

         Vector var8 = new Vector();
         DBColumnDisplayInfo var2 = new DBColumnDisplayInfo("seqid", "number");
         var8.add(var2);
         var2 = new DBColumnDisplayInfo("tablename", "varchar");
         var8.add(var2);
         var2 = new DBColumnDisplayInfo("pkname", "varchar");
         var8.add(var2);
         DBTableModel var9 = new DBTableModel(var8);
         int[] var10 = this.getMasterModel().getTable().getSelectedRows();

         String var4;
         for(int var3 = 0; var3 < var10.length; ++var3) {
            var4 = this.getMasterModel().getItemValue(var10[var3], "approveflag");
            String var5 = this.getMasterModel().getItemValue(var10[var3], "usestatus");
            if ("2".equals(var4) || "0".equals(var4)) {
               this.warnMessage("警告", "没有审批，不能送审！");
               return;
            }

            if (!"1".equals(var5)) {
               this.warnMessage("警告", "不是临时状态，不能送审！");
               return;
            }

            if ((var5 = this.getMasterModel().getItemValue(var10[var3], "wfusestatus")) == null) {
               var5 = "";
            }

            if (!"".equals(var5)) {
               this.warnMessage("警告", "不能选择已送审的单据进行送审!");
               return;
            }

            int var13 = var9.getRowCount();
            var9.appendRow();
            var9.setItemValue(var13, "seqid", this.getMasterModel().getItemValue(var10[var3], "conid"));
            var9.setItemValue(var13, "tablename", "BMS_SA_CON_DOC");
            var9.setItemValue(var13, "pkname", "conid");
         }

         if (var9.getRowCount() <= 0) {
            this.warnMessage("警告", "请选择正确单据进行送审");
         } else if (JOptionPane.showConfirmDialog(this.getParentFrame(), "是否要送审选中单据？", "提示", 2) == 0) {
            ClientRequest var14;
            (var14 = new ClientRequest()).addCommand(new StringCommand("Bms_wfappr.审批流送审"));
            DataCommand var16;
            (var16 = new DataCommand()).setDbmodel(var9);
            var14.addCommand(var16);
            ServerResponse var17 = null;

            try {
               var17 = SendHelper.sendRequest(var14);
            } catch (Exception var7) {
               this.errorMessage("错误", var7.getMessage());
               var7.printStackTrace();
            }

            if (!(var4 = ((StringCommand)var17.commandAt(0)).getString()).startsWith("+OK")) {
               this.infoMessage("错误", var4);
            } else {
               for(int var11 = 0; var11 < var9.getRowCount(); ++var11) {
                  String var12 = var9.getItemValue(var11, "seqid");
                  DBTableModel var15 = this.getMasterModel().getDBtableModel();

                  for(int var18 = 0; var18 < var15.getRowCount(); ++var18) {
                     if (var15.getItemValue(var18, "conid").equals(var12)) {
                        var15.setItemValue(var18, "wfusestatus", "1");
                        var15.setdbStatus(var18, 0);
                        break;
                     }
                  }
               }

               this.getMasterModel().tableChanged();
               this.infoMessage("提示！", "送审成功！");
            }
         }
      }
   }

   protected boolean chkCompanyLicense(String var1, String var2, String var3, String var4, int var5) {
      ClientRequest var6 = new ClientRequest();
      StringCommand var7 = new StringCommand("证照管理:证照期限检查");
      ParamCommand var8 = new ParamCommand();
      String var9 = null;
      String var10 = null;
      boolean var11 = true;
      var8.addParam("companyid", var1);
      var8.addParam("goodsid", var2);
      var8.addParam("permitoverdays", var3);
      var8.addParam("warndays", var4);
      var6.addCommand(var7);
      var6.addCommand(var8);
      ServerResponse var12;
      if (((StringCommand)(var12 = SendHelper.sendRequest(var6)).commandAt(0)).getString().startsWith("+OK")) {
         ParamCommand var13;
         var9 = (var13 = (ParamCommand)var12.commandAt(1)).getValue("message");
         var10 = var13.getValue("flag");
         if (var9 != null && var9.length() > 0) {
            this.infoMessage("提示", var9);
         }
      }

      if (var10 != null && var10.equals("0")) {
         var11 = false;
      }

      if (var11) {
         return true;
      } else {
         if (var2 != null && var2.length() != 0) {
            this.detailmodel.setItemValue(var5, "opcode", "");
            this.detailmodel.setItemValue(var5, "goodsid", "");
            this.detailmodel.setItemValue(var5, "goodsname", "");
            this.detailmodel.setItemValue(var5, "goodsno", "");
            this.detailmodel.setItemValue(var5, "goodsunit", "");
            this.detailmodel.setItemValue(var5, "goodsdtlid", "");
            this.detailmodel.setItemValue(var5, "currencyname", "");
            this.detailmodel.setItemValue(var5, "factoryname", "");
            this.detailmodel.setItemValue(var5, "prodarea", "");
            this.detailmodel.setItemValue(var5, "packsize", "");
            this.detailmodel.setItemValue(var5, "packname", "");
            this.detailmodel.setItemValue(var5, "goodstype", "");
         } else {
            this.mastermodel.setItemValue(var5, "customopcode", "");
            this.mastermodel.setItemValue(var5, "customid", "");
            this.mastermodel.setItemValue(var5, "customno", "");
            this.mastermodel.setItemValue(var5, "customname", "");
         }

         return false;
      }
   }
}
